/* Risk.prg
Calculates asymptotic risk and risk bounds
Creates Figure 1 in "Efficient Shrinkage in Parametric Models"
This is a Gauss program file
*/

rep=1000000;
cn=61;
cmax=6;
cc=seqa(0,cmax/(cn-1),cn);

let ps = 4 8 12 20;
pn=rows(ps);

b=(1-((1-2./(ps'))^2)./(1+cc));
b0=(cc./(1+cc));

risk=zeros(cn,pn);

for pii (1,pn,1);
p=ps[pii];

for ci (1,cn,1);

c=cc[ci];
h=ones(1,p)*sqrt(c);
z=rndn(rep,p)+h;
w=1-(p-2)./sumc((z.^2)');
w=w.*(w.>0);
t=z.*w-h;
risk[ci,pii]=meanc(sumc((t.^2)'))/p;

endfor;
endfor;


library pgraph;
pqgwin many;
graphset;
_pdate="";
_plwidth=4;
let _pmcolor = 0 0 0 0 0 0 0 0 15;
fonts("complex simgrma");
_pcolor=1;
xtics(0,6,1,4);
let _pltype = 3 6 1;
ylabel("Risk");
xlabel("c");
_plegstr="Bound\000Risk\000Large p Bound";
_plegctl=1;



begwind;
window(2,2,0);
for pii (1,pn,1);
  p=ps[pii];
  mle=zeros(cn,1)+p;
  setwind(pii);
  ytics(0,1,.2,2);
  tit = "" $+ "p=" $+ ftocv(p,1,0);
  title(tit);
  xy(cc,b[.,pii]~risk[.,pii]~b0);
endfor;
endwind;